//Playing Grains
//Officially called the "Genghar's Cuatom Pseudo Random Noise".
//Yes, CUATOM. Called so from my misspelled "custom". Sounds deliberate eh?

float grain(float2 UV, float seed) {
    UV = fmod(UV, 147.0);
    float uv1 = frac(dot(UV, float2(5412.051,241.053)));
    float uv2 = frac(dot(UV, float2(182.051,2186.15)));

    float2 hax = float2(uv1, uv2) * frac(dot(UV,UV)) * 42610.0 * abs(seed);

    float4 dis = float4(hax.y, frac(seed) * 1.0-hax.x, frac(seed) * 1.0-hax.y, hax.x);
    float4 haxr = float4(hax, hax * frac(seed));
    float final = (distance(dis, haxr)+length(dis)+length(haxr))/3.0;

    return fmod(final, 1.0);
}

float granular(float2 UV, float t) {
    float uv1 = frac(sin(dot(UV, float2(5412.051,241.053)))*42610.0+t);
    float uv2 = frac(cos(dot(UV, float2(182.051,2186.15)))*42160.0+t);

    return uv1*uv2;
}

//2D Perlin Noise, Using Granular as random noise generator
float noice(float2 st, float t) {
    float2 i = floor(st);
    float2 f = frac(st);

    float a = granular(i,t);
    float b = granular(i + float2(1.0, 0.0),t);
    float c = granular(i + float2(0.0, 1.0),t);
    float d = granular(i + float2(1.0, 1.0),t);

    float2 u = smoothstep(0.0, 1.0, f);
    return lerp(a, b, u.x) + (c - a) * u.y * (1.0 - u.x) + (d - b) * u.x * u.y;
}

//Fractal Brownian Motion noise
float fbm(float2 st, float t) {
    float value = 0.0;
    float amplitude = .75;
    float frequency = 0.;
    for(int i = 0; i < 12; i++) {
        value += amplitude * noice(st,t);
        st *= 2.;
        amplitude *= .5;
    }
    return value;
}/**/