#include "ShaderConstants.fxh"

#include "function/grain.hlsl"

struct PS_Input
{
    float4 position : SV_Position;
    float4 color : COLOR;
    float3 skypos : SKYPOS;
};

struct PS_Output
{
    float4 color : SV_Target;
};

ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput) {
    float4 clr = PSInput.color;
    float2 sp = skypos.xz;
    clr.rgb = lerp(clr.rgb, float3(1.0, 1.0, 1.0), fbm(sp*130.0, TIME));
    PSOutput.color = clr;
}