#include "ShaderConstants.fxh"
#include "util.fxh"

struct PS_Input
{
    float4 position : SV_Position;
    float2 uv : TEXCOORD_0_FB_MSAA;
    float2 solarpos : SP;
};

struct PS_Output
{
    float4 color : SV_Target;
};

ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput) {
    float origin = 1.0-pow((length(PSInput.solarpos.x-PSInput.solarpos.y)+length(-PSInput.solarpos.x-PSInput.solarpos.y)) * 4.0, 3.0);
    float3 clr = float3(origin, origin, origin);

    PSOutput.color = float4(clr, 1.0);
    #ifdef WINDOWSMR_MAGICALPHA
        // Set the magic MR value alpha value so that this content pops over layers
        PSOutput.color.a = 133.0f / 255.0f;
    #endif
}
